/**
 * Benchmark Test Header file
 *
 * @author: W. David Frohlingsdorf
 * @date: 2016
 * @purpose: Dissertation, University of Glasgow
 * */

#include <iostream>
#include <thread>
#include <mutex>

// * * Threads * * //
#define BENCHMARK_THREAD_TYPE          thread
#define BENCHMARK_INIT_THREAD(id,func) ;
#define BENCHMARK_RUN_THREAD(id,func)  id = thread(func)
#define BENCHMARK_JOIN_THREAD(id)      id.join()
#define FUNC_ARG_TYPE                  void
#define FUNC_RET_TYPE                  void
//#define FUNC_RET_VAL                   void
// * * Locks * * //
#define BENCHMARK_LOCK_TYPE            mutex
#define BENCHMARK_INIT_LOCK(id)        ;
#define BENCHMARK_LOCK(id)             id.lock()
#define BENCHMARK_UNLOCK(id)           id.unlock()

