/**
 * Benchmark Test Header file
 *
 * @author: W. David Frohlingsdorf
 * @date: 2016
 * @purpose: Dissertation, University of Glasgow
 * */

#include "inheritance_lock_api.h"
//Set this file as header in the makefile

// * * Threads * * //
#define BENCHMARK_THREAD_TYPE          pthread_t
#define BENCHMARK_INIT_THREAD(id,func) ;
#define BENCHMARK_RUN_THREAD(id,func)  pthread_create(&id, NULL, func, NULL)
#define BENCHMARK_JOIN_THREAD(id)      pthread_join(id, NULL)
#define FUNC_ARG_TYPE                  void*
#define FUNC_RET_TYPE                  void*
#define FUNC_RET_VAL                   NULL
// * * Locks * * //
#define BENCHMARK_LOCK_TYPE            INHERIT_LOCK
#define BENCHMARK_INIT_LOCK(id)        create_rec_lock(&id)
#define BENCHMARK_LOCK(id)             acquire(id)
#define BENCHMARK_UNLOCK(id)           release(id)
