/**
 * Benchmark Test Header file
 *
 * @author: W. David Frohlingsdorf
 * @date: 2016
 * @purpose: Dissertation, University of Glasgow
 * */

#include <pthread.h>

// * * Threads * * //
#define BENCHMARK_THREAD_TYPE          pthread_t
#define BENCHMARK_INIT_THREAD(id,func) ;
#define BENCHMARK_RUN_THREAD(id,func)  pthread_create(&id, NULL, func, NULL)
#define BENCHMARK_JOIN_THREAD(id)      pthread_join(id, NULL)
#define FUNC_ARG_TYPE                  void*
#define FUNC_RET_TYPE                  void*
#define FUNC_RET_VAL                   NULL
// * * Locks * * //
#define BENCHMARK_LOCK_TYPE            int
#define BENCHMARK_INIT_LOCK(id)        ;
#define BENCHMARK_LOCK(id)             ;
#define BENCHMARK_UNLOCK(id)           ;
// * * Transactions * * //
#define BENCHMARK_BEGIN_TRANS          __transaction_atomic{
#define BENCHMARK_END_TRANS            }
