import re
import sys

with open(sys.argv[1]) as f:
  for line in f:
    splited = re.split('(=)|(,)|(})', line)
    for s in splited:
      if s is not None:
        f = 0.0
        floated = False
        try:
          f = float(s)
          if f > 1000.0:
            f = f / 1000000
            floated = True
        except ValueError:
          floated = False
        if floated:
          sys.stdout.write(str(f))
        else:
          sys.stdout.write(s)

sys.stdout.flush()
