/**
 * Test program for gcc transactional memory
 *
 * @author: W. David Frohlingsdorf
 * @date: 2016
 * @purpose: Dissertation, University of Glasgow
 * 
 * This source file contains some simple trials
 * to test the build-in functionality of the gcc
 * transactional memory (tm).
 * Please compile with:
 * gcc -fgnu-tm stmTest.c -o stmTest 
 * */


#include <stdio.h>

int main()
{
    int a,b,c;
    a = 7;
    b = 2;
    __transaction_atomic
    {
        c = a - b;
        __transaction_atomic
        {
            c = a + b;
        }
    }
    printf("c = %d\n", c);
    return 0;
}
