
SEARCH_DEPTH = 10000000
MAX_STEPS    = 10000
RANDOM_SEED  = 123
MEMORY_LIMIT = 32768 # In MB

verify:
	spin -a model.pml
	gcc -DMEMLIM=$(MEMORY_LIMIT) -O2 -DXUSAFE -DNFAIR=3 -DCOLLAPSE -w -o pan pan.c
	./pan -m$(SEARCH_DEPTH) -a -f 
	rm pan*
	rm *.tmp

simulate:
	spin -p -s -r -X -v -n$(RANDOM_SEED) -l -g -u$(MAX_STEPS) model.pml

creator: creator.hs
	ghc $^
	rm creator.o
	rm creator.hi
