#!/bin/bash

#
# First argument:  Number of locks
# Second argument: Name of the PC
#
# Always check for 2-10 threads (one thread crashes)
#
# Every PC checks first for 2-10 threads
# on specified number of locks
#
# Then all PCs check for 2-3 lock
# with 2-10 threads
#

l=2  #Lower number of threads
u=10 #Upper number of threads
t=3  #Common number of locks

mkdir ./remoteArchive/$1.$2
cp ./Makefile ./remoteArchive/$1.$2/
cp ./creator ./remoteArchive/$1.$2/
cd ./remoteArchive/$1.$2/

for i in `seq $l $u`;
do
  ./creator $i $1 > model.pml
  make verify > $i.$1.$2.txt
done   

for i in `seq $l $u`;
do
  for j in `seq 1 $t`;
  do
    ./creator $i $j > model.pml
    make verify > $i.$j.$2.txt
  done
done

rm ./model*
rm ./creator
rm ./Makefile

