#!/bin/bash

# First argument:  Password
# Second argument: Room
# Third argument:  Limit

ROUND=1 # 3 Rounds
COUNT=4 # Assign 4 to 10

strZero="0"
strDash="-"
strSuffix="u"

for i in `seq 1 $3`;
do
  if [ $i -lt 10 ]; then 
    target=$2$strDash$strZero$i$strSuffix
  else
    target=$2$strDash$i$strSuffix
  fi
  expect ./login.exp $target $1 
  if [ $? -eq 1 ]; then
    COUNT=$((COUNT+1))
    if [ $COUNT -eq 11 ]; then
      ROUND=$((ROUND+1))
      COUNT=4
      if [ $ROUND -eq 4 ]; then
        echo "ALL DONE! Last PC to be assigned was: $target"
      fi
    fi
  fi
done

echo "Reached upper limit. Next values would be ROUND=$ROUND COUNT=$COUNT"
